#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <iostream>
#include "VaRGB.h"
#include "VaRGBCurves.h"


//#include "includes/VaRGBPlatform.h"
//#include "includes/Schedule.h"
//#include "includes/Curve.h"

#define byte uint8_t 
#define RED_PIN 18
#define GREEN_PIN 23
#define BLUE_PIN  24
double  PWM_SCALER = 1/double(VaRGB_GENERIC_PLAT_COLORVALUE_MAX);
FILE *fp;
void  INThandler(int sig)
{
    int pin;
        signal(sig, SIG_IGN);
    //turn all pins off
        for (pin = 0; pin < 8; pin++){
        fprintf(fp, "%i=%f\n", pin,0.0);
        fflush(fp);
    }
    fclose(fp);
    exit(0);
}

/* *** The VaRGB driver object *** */

// callback declarations.
// We need a color-setting callback and a another 
// callback for when a schedule has run its course, 
// in order to create our VaRGB driver.

// these are forward declarations, the actual functions
// are defined below.  You can change the names, but not 
// the signatures (void return and their respective parameters):
void setColorValues(vargb::ColorSettings * set_to);
void scheduleCompleteCB(vargb::Schedule * sched);


// with our callbacks recognizable by the compiler as functions of the 
// correct types, we create the VaRGB driver object:
vargb::VaRGB RGB_prog(setColorValues, scheduleCompleteCB);
#define number_of_schedules  2
vargb::Schedule * available_schedules[number_of_schedules] = {
      new vargb::Schedule(),
      new vargb::Schedule(),
  
};
/* *** Curves -- the RGB transition specifications *** */

// As mentioned, a schedule is comprised of one or more curves.  These curves 
// describe the behaviour of the RGB settings with time.
//
// There are a few kinds of curves available with the library, like:
//
//  * Linear -- each RGB component varies linearly with time (a constant 
//              slope), like a simple "fade" in or out
//  
//  * Sine -- RGB components vary as sine waves, so quickly around their 
//              mid-point and slower at the extremes
//
//  * Flasher -- RGB components are alternated between 0 and their setting
//
// In addition, there are "combo" curves which allow you to combine 
// other curves with AND or OR logic.  These are left for another example.

// now, let's create a few of these curves...

// a single "white" flasher, for schedule 0
#define num_flashes      20
#define time_flashing    6
vargb::Curve::Flasher * flasher_curve = new vargb::Curve::Flasher(VaRGB_COLOR_MAXVALUE, 
                                                        VaRGB_COLOR_MAXVALUE, VaRGB_COLOR_MAXVALUE, 
                                                        time_flashing, num_flashes);

// a green-tinted sine wave, for schedule 0: say 5 cycles of 2 seconds each 
// (total run time of 10 seconds)
#define sine_runtime                 6
#define sinewave_seconds_per_cycle   2
vargb::Curve::Sine * green_sine_wave = new vargb::Curve::Sine(500, VaRGB_COLOR_MAXVALUE, 500, 
                                                          sine_runtime, sinewave_seconds_per_cycle);



// a sequence of linear "fades" for schedule 2, store in an array for convenience
#define num_curves_schedule1  5
vargb::Curve::Linear * schedule1_curves[num_curves_schedule1] = {
 
                            // start black
                            new vargb::Curve::Linear(0,0,0,       0), 
                            // go to ~1/2 red, over one 5 seconds
                            new vargb::Curve::Linear(500,0,0,     5), 
                            // go to red+blue, over 2s
                            new vargb::Curve::Linear(1000,0,1000, 2), 
                            // back down to ~1/2 red over 2s
                            new vargb::Curve::Linear(500,0,0,     2), 
                            // fade to black for 5s
                            new vargb::Curve::Linear(0,0,0,       5), 
};


void scheduleCompleteCB(vargb::Schedule * sched)
{
  // when a schedule has completely run through all of its transitions,
  // this callback is called, with the just-terminated schedule as 
  // the parameter.
  
  // use this function to do whatever you like, e.g. change the schedule
  // as we're doing here.
  
  // one important thing is to call resetTicks() if you just want to start
  // from the begining (of this or another schedule):
  
  //fprintf(fp, "Schdedule Completetd Id=%i\n", sched->id() );
  //fflush(fp);
  RGB_prog.resetTicks();
  
  
  // in this case, we'll move on to the next schedule
  byte next_id = sched->id() + 1;
  if (next_id >= number_of_schedules )
  {
    next_id = 0; // past end, so loop back to first schedule...
  }
  RGB_prog.setSchedule(available_schedules[next_id]);
  
}
  


void setColorValues(vargb::ColorSettings * set_to)
{
  //fprintf(fp, "ColorSettings PWMScaler=%f\n",PWM_SCALER);
  //fprintf(fp, "ColorSettings Test=%f\n",0.0001);
  //fprintf(fp, "VaRGB_GENERIC_PLAT_COLORVALUE_MAX=%i\n",VaRGB_GENERIC_PLAT_COLORVALUE_MAX);
  //fflush(fp);
  // the color-setting callback, specified in this examples as this
  // "setColorCB()" function, is called whenever there a change
  // to the RGB color settings is required.
  //fprintf(fp, "SetTo-Red = %f\n",set_to->red );
  //fflush(fp);
  fprintf(fp, "%i=%f\n", RED_PIN, double(set_to->red * PWM_SCALER) );
  fflush(fp);
  //fprintf(fp, "SetTo-Green = %f\n",set_to->green );
  //fflush(fp);
  fprintf(fp, "%i=%f\n", GREEN_PIN,double(set_to->green * PWM_SCALER) );
  fflush(fp);
  //fprintf(fp, "SetTo-Blue = %f\n",set_to->blue );
  //fflush(fp);
  fprintf(fp, "%i=%f\n", BLUE_PIN,double(set_to->blue * PWM_SCALER) );
  fflush(fp);



}


int main(void)
{
    signal(SIGINT, INThandler);
    //need for initializing wiringPI delay method
    wiringPiSetupSys();
 
   
    // open the pi-blaster device file. If it fails, confirm that pi-blaster has been started
    fp = fopen("/dev/pi-blaster", "w");
    //fp = fopen("./pi-blaster.log", "w");
    if (fp == NULL) {
        printf("Error opening file\n");
        exit(0);
     }
   
 







/* *** Callbacks *** */

// these are the callbacks used by the VaRGB driver, that we promised we would
// be defining above (the forward declarations)
  // Tell the schedules what curves each is responsible for:
  
  
  
  // add the flasher to the first schedule (0):
  available_schedules[0]->addTransition(flasher_curve);
  // then add the sinewave here too
  available_schedules[0]->addTransition(green_sine_wave);
  
  
  
  // add all the linear to the second program
  for (byte i=0; i< num_curves_schedule1; i++)
  {
    available_schedules[1]->addTransition(schedule1_curves[i]);
  }
  
  
  // Finally, tell our VaRGB driver where to begin (schedule 0)
  RGB_prog.setSchedule(available_schedules[0]);
  while(true){
      //fprintf(fp, "RGB_prog.tickAndDelay()\n");
      //fflush(fp);
      RGB_prog.tickAndDelay();
  
}
    fclose(fp);
    return 0;
}




